Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 84375)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 84376)
@@ -314,4 +314,22 @@
 {
     return uId.toString().remove(QRegExp("[{}]"));
+}
+
+/* static */
+QString UIChooserAbstractModel::definitionOption(NodeDef enmOption)
+{
+    switch (enmOption)
+    {
+        /* Global nodes: */
+        case NodeDef_GlobalPrefix:         return "n";
+        case NodeDef_GlobalOptionFavorite: return "f";
+        case NodeDef_GlobalValueDefault:   return "GLOBAL";
+        /* Machine nodes: */
+        case NodeDef_MachinePrefix:        return "m";
+        /* Group nodes: */
+        case NodeDef_GroupPrefix:          return "g";
+        case NodeDef_GroupOptionOpened:    return "o";
+    }
+    return QString();
 }
 
@@ -699,5 +717,7 @@
 
     /* Prepare required group definition reg-exp: */
-    const QString strDefinitionTemplate = QString("g(\\S)*=%1").arg(strName);
+    const QString strNodePrefix = definitionOption(NodeDef_GroupPrefix);
+    const QString strNodeOptionOpened = definitionOption(NodeDef_GroupOptionOpened);
+    const QString strDefinitionTemplate = QString("%1(\\S)*=%2").arg(strNodePrefix, strName);
     const QRegExp definitionRegExp(strDefinitionTemplate);
     /* For each the group definition: */
@@ -709,5 +729,5 @@
             /* Get group descriptor: */
             const QString strDescriptor(definitionRegExp.cap(1));
-            if (strDescriptor.contains('o'))
+            if (strDescriptor.contains(strNodeOptionOpened))
                 return true;
         }
@@ -744,6 +764,9 @@
 
     /* Prepare required group definition reg-exp: */
-    const QString strDefinitionTemplate = QString("n(\\S)*=GLOBAL");
-    const QRegExp definitionRegExp = QRegExp(strDefinitionTemplate);
+    const QString strNodePrefix = definitionOption(NodeDef_GlobalPrefix);
+    const QString strNodeOptionFavorite = definitionOption(NodeDef_GlobalOptionFavorite);
+    const QString strNodeValueDefault = definitionOption(NodeDef_GlobalValueDefault);
+    const QString strDefinitionTemplate = QString("%1(\\S)*=%2").arg(strNodePrefix, strNodeValueDefault);
+    const QRegExp definitionRegExp(strDefinitionTemplate);
     /* For each the group definition: */
     foreach (const QString &strDefinition, definitions)
@@ -754,5 +777,5 @@
             /* Get group descriptor: */
             const QString strDescriptor(definitionRegExp.cap(1));
-            if (strDescriptor.contains('f'))
+            if (strDescriptor.contains(strNodeOptionFavorite))
                 return true;
         }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h	(revision 84375)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.h	(revision 84376)
@@ -65,4 +65,15 @@
 public:
 
+    /** Extra-data node definition option types. */
+    enum NodeDef
+    {
+        NodeDef_GlobalPrefix,
+        NodeDef_GlobalOptionFavorite,
+        NodeDef_GlobalValueDefault,
+        NodeDef_MachinePrefix,
+        NodeDef_GroupPrefix,
+        NodeDef_GroupOptionOpened,
+    };
+
     /** Constructs abstract Chooser-model passing @a pParent to the base-class. */
     UIChooserAbstractModel(UIChooser *pParent);
@@ -109,4 +120,7 @@
           * @note  Required for backward compatibility after QString=>QUuid change. */
         static QString toOldStyleUuid(const QUuid &uId);
+
+        /** Returns extra-data node definition option of certain @a enmType. */
+        static QString definitionOption(NodeDef enmType);
     /** @} */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 84375)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 84376)
@@ -222,5 +222,5 @@
     const QString strItemDescriptor = strDefinition.section('=', 1, -1);
     /* Its a group-item definition? */
-    if (strItemType == "g")
+    if (strItemType == definitionOption(NodeDef_GroupPrefix))
     {
         /* Search for group-item with passed descriptor (name): */
@@ -232,5 +232,5 @@
     }
     /* Its a global-item definition? */
-    else if (strItemType == "n")
+    else if (strItemType == definitionOption(NodeDef_GlobalPrefix))
     {
         /* Search for global-item with required name: */
@@ -240,5 +240,5 @@
     }
     /* Its a machine-item definition? */
-    else if (strItemType == "m")
+    else if (strItemType == definitionOption(NodeDef_MachinePrefix))
     {
         /* Search for machine-item with required ID: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.cpp	(revision 84375)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.cpp	(revision 84376)
@@ -17,4 +17,5 @@
 
 /* GUI includes: */
+#include "UIChooserAbstractModel.h"
 #include "UIChooserNodeGlobal.h"
 
@@ -77,7 +78,10 @@
 QString UIChooserNodeGlobal::definition(bool fFull /* = false */) const
 {
+    const QString strNodePrefix = UIChooserAbstractModel::definitionOption(UIChooserAbstractModel::NodeDef_GlobalPrefix);
+    const QString strNodeOptionFavorite = UIChooserAbstractModel::definitionOption(UIChooserAbstractModel::NodeDef_GlobalOptionFavorite);
+    const QString strNodeValueDefault = UIChooserAbstractModel::definitionOption(UIChooserAbstractModel::NodeDef_GlobalValueDefault);
     return   fFull
-           ? QString("n%1=%2").arg(isFavorite() ? "f" : "").arg("GLOBAL")
-           : QString("n=%1").arg("GLOBAL");
+           ? QString("%1%2=%3").arg(strNodePrefix).arg(isFavorite() ? strNodeOptionFavorite : "").arg(strNodeValueDefault)
+           : QString("%1=%2").arg(strNodePrefix).arg(strNodeValueDefault);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp	(revision 84375)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp	(revision 84376)
@@ -17,4 +17,5 @@
 
 /* GUI includes: */
+#include "UIChooserAbstractModel.h"
 #include "UIChooserNodeGroup.h"
 #include "UIChooserNodeGlobal.h"
@@ -107,7 +108,9 @@
 QString UIChooserNodeGroup::definition(bool fFull /* = false */) const
 {
+    const QString strNodePrefix = UIChooserAbstractModel::definitionOption(UIChooserAbstractModel::NodeDef_GroupPrefix);
+    const QString strNodeOptionOpened = UIChooserAbstractModel::definitionOption(UIChooserAbstractModel::NodeDef_GroupOptionOpened);
     return   fFull
-           ? QString("g%1=%2").arg(isOpened() ? "o" : "").arg(name())
-           : QString("g=%1").arg(fullName());
+           ? QString("%1%2=%3").arg(strNodePrefix).arg(isOpened() ? strNodeOptionOpened : "").arg(name())
+           : QString("%1=%2").arg(strNodePrefix).arg(fullName());
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp	(revision 84375)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp	(revision 84376)
@@ -138,5 +138,6 @@
 QString UIChooserNodeMachine::definition(bool) const
 {
-    return QString("m=%1").arg(UIChooserAbstractModel::toOldStyleUuid(id()));
+    const QString strNodePrefix = UIChooserAbstractModel::definitionOption(UIChooserAbstractModel::NodeDef_MachinePrefix);
+    return QString("%1=%2").arg(strNodePrefix).arg(UIChooserAbstractModel::toOldStyleUuid(id()));
 }
 