Index: trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 84345)
+++ trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 84394)
@@ -509,7 +509,7 @@
                         if (NT_SUCCESS(rcNt))
                         {
-                            PSUPDRVDEVEXTERRORINFO pDevExtStub = (PSUPDRVDEVEXTERRORINFO)g_pDevObjStub->DeviceExtension;
-                            pDevExtStub->Common.pMainDrvExt = (PSUPDRVDEVEXT)g_pDevObjSys->DeviceExtension;
-                            pDevExtStub->Common.u32Cookie   = SUPDRVDEVEXTERRORINFO_COOKIE;
+                            PSUPDRVDEVEXTERRORINFO pDevExtErrInf = (PSUPDRVDEVEXTERRORINFO)g_pDevObjStub->DeviceExtension;
+                            pDevExtErrInf->Common.pMainDrvExt = (PSUPDRVDEVEXT)g_pDevObjSys->DeviceExtension;
+                            pDevExtErrInf->Common.u32Cookie   = SUPDRVDEVEXTERRORINFO_COOKIE;
 
 #endif
@@ -3171,5 +3171,5 @@
             AssertRCSuccess(rc);
 
-            bool fDone = supdrvNtProtectGetAlpcPortObjectType2(wszPortNm, &pObjType);
+            fDone = supdrvNtProtectGetAlpcPortObjectType2(wszPortNm, &pObjType);
             if (!fDone)
             {
@@ -4734,5 +4734,5 @@
             continue;
         PEPROCESS pDbgProc;
-        NTSTATUS rcNt = PsLookupProcessByProcessId(pHandleInfo->UniqueProcessId, &pDbgProc);
+        rcNt = PsLookupProcessByProcessId(pHandleInfo->UniqueProcessId, &pDbgProc);
         if (NT_SUCCESS(rcNt))
         {
Index: trunk/src/VBox/HostDrivers/Support/win/SUPR3HardenedMain-win.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/SUPR3HardenedMain-win.cpp	(revision 84345)
+++ trunk/src/VBox/HostDrivers/Support/win/SUPR3HardenedMain-win.cpp	(revision 84394)
@@ -4346,5 +4346,5 @@
            assume same location as in the parent (safe): */
         PSUPHNTLDRCACHEENTRY pLdrEntryKernel32;
-        int rc = supHardNtLdrCacheOpen("kernel32.dll", &pLdrEntryKernel32, NULL /*pErrInfo*/);
+        rc = supHardNtLdrCacheOpen("kernel32.dll", &pLdrEntryKernel32, NULL /*pErrInfo*/);
         if (RT_FAILURE(rc))
             supR3HardenedWinKillChild(pThis, "supR3HardenedWinSetupChildInit", rc,
@@ -4542,10 +4542,10 @@
                     uint8_t abPadding[4096];
                 } uBuf;
-                NTSTATUS rcNt = NtQueryVirtualMemory(pThis->hProcess,
-                                                     MemInfo.BaseAddress,
-                                                     MemorySectionName,
-                                                     &uBuf,
-                                                     sizeof(uBuf) - sizeof(WCHAR),
-                                                     &cbActual);
+                rcNt = NtQueryVirtualMemory(pThis->hProcess,
+                                            MemInfo.BaseAddress,
+                                            MemorySectionName,
+                                            &uBuf,
+                                            sizeof(uBuf) - sizeof(WCHAR),
+                                            &cbActual);
                 if (NT_SUCCESS(rcNt))
                 {
@@ -6018,5 +6018,5 @@
          * Print basic file information available via NtQueryInformationFile.
          */
-        IO_STATUS_BLOCK Ios = RTNT_IO_STATUS_BLOCK_INITIALIZER;
+        RTNT_IO_STATUS_BLOCK_REINIT(&Ios);
         rcNt = NtQueryInformationFile(hFile, &Ios, &u.BasicInfo, sizeof(u.BasicInfo), FileBasicInformation);
         if (NT_SUCCESS(rcNt) && NT_SUCCESS(Ios.Status))
@@ -6031,4 +6031,5 @@
             SUP_DPRINTF(("    FileBasicInformation -> %#x %#x\n", rcNt, Ios.Status));
 
+        RTNT_IO_STATUS_BLOCK_REINIT(&Ios);
         rcNt = NtQueryInformationFile(hFile, &Ios, &u.StdInfo, sizeof(u.StdInfo), FileStandardInformation);
         if (NT_SUCCESS(rcNt) && NT_SUCCESS(Ios.Status))
@@ -6041,4 +6042,5 @@
          */
         RT_ZERO(u);
+        RTNT_IO_STATUS_BLOCK_REINIT(&Ios);
         LARGE_INTEGER offRead;
         offRead.QuadPart = 0;
@@ -6102,4 +6104,5 @@
                         if (offRead.QuadPart > 0)
                         {
+                            RTNT_IO_STATUS_BLOCK_REINIT(&Ios);
                             RT_ZERO(u);
                             rcNt = NtReadFile(hFile, NULL /*hEvent*/, NULL /*ApcRoutine*/, NULL /*ApcContext*/, &Ios,