Index: trunk/src/VBox/Additions/3D/win/VBoxGL/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/3D/win/VBoxGL/Makefile.kmk	(revision 84410)
+++ trunk/src/VBox/Additions/3D/win/VBoxGL/Makefile.kmk	(revision 84411)
@@ -28,5 +28,5 @@
 # -wd4005: '__useHeader' : redefinition
 VBoxGL_CFLAGS  := -wd4005
-if "$(VBOX_NEWER_VCC_TOOL_STEM)" >= "VCC141"
+if "$(VBOX_NEWER_VCC_TOOL_STEM)" >= "VCC140"
 # -wd4204: nonstandard extension used: non-constant aggregate initializer
 # -wd4459: stw_device.h(102): warning C4459: declaration of 'stw_dev' hides global declaration
Index: trunk/src/VBox/Devices/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/Makefile.kmk	(revision 84410)
+++ trunk/src/VBox/Devices/Makefile.kmk	(revision 84411)
@@ -1482,5 +1482,5 @@
  TEMPLATE_VBoxSVGA3D_EXTENDS := $(if-expr "$(KBUILD_TARGET)" == "darwin" && !defined(VBOX_WITH_NEW_XCODE),VBoxR3DllOsX107,VBOXR3)
  TEMPLATE_VBoxSVGA3D_CFLAGS      = $(filter-out -pedantic -Wstrict-prototypes,$(TEMPLATE_$(TEMPLATE_VBoxSVGA3D_EXTENDS)_CFLAGS))
- if "$(VBOX_VCC_TOOL_STEM)" >= "VCC141"
+ if "$(VBOX_VCC_TOOL_STEM)" >= "VCC140"
   # -wd4777: glsl_shader.c(1542): warning C4777: 'sprintf' : format string '%u' requires an argument of type 'unsigned int', but variadic argument 2 has type 'DWORD'
   TEMPLATE_VBoxSVGA3D_CFLAGS.win = $(TEMPLATE_$(TEMPLATE_VBoxSVGA3D_EXTENDS)_CFLAGS.win) \
Index: trunk/src/VBox/ExtPacks/VBoxDTrace/Makefile.kmk
===================================================================
--- trunk/src/VBox/ExtPacks/VBoxDTrace/Makefile.kmk	(revision 84410)
+++ trunk/src/VBox/ExtPacks/VBoxDTrace/Makefile.kmk	(revision 84411)
@@ -65,5 +65,5 @@
  TEMPLATE_VBoxR3ExtPackDTrace_INST = $(INST_EXTPACK_VBOXDTRACE)$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)/
  TEMPLATE_VBoxR3ExtPackDTrace_DEFS = $(TEMPLATE_VBoxR3ExtPack_DEFS) VBOX_IN_DTRACE_EXTPACK
- if "$(VBOX_VCC_TOOL_STEM)" >= "VCC141"
+ if "$(VBOX_VCC_TOOL_STEM)" >= "VCC140"
   # -wd4456: declaration of 'rval' hides previous local declaration
   # -wd4477: 'fprintf' : format string '%02lu' requires an argument of type 'unsigned long', but variadic argument 1 has type 'ulong_t'
Index: trunk/src/VBox/Main/include/SessionImpl.h
===================================================================
--- trunk/src/VBox/Main/include/SessionImpl.h	(revision 84410)
+++ trunk/src/VBox/Main/include/SessionImpl.h	(revision 84411)
@@ -29,5 +29,5 @@
 #endif
 
-#if defined(RT_OS_WINDOWS) && !RT_MSC_PREREQ(RT_MSC_VER_VC141)
+#if defined(RT_OS_WINDOWS) && !RT_MSC_PREREQ(RT_MSC_VER_VC140)
 [threading(free)]
 #endif
Index: trunk/src/VBox/Main/webservice/Makefile.kmk
===================================================================
--- trunk/src/VBox/Main/webservice/Makefile.kmk	(revision 84410)
+++ trunk/src/VBox/Main/webservice/Makefile.kmk	(revision 84411)
@@ -216,5 +216,5 @@
 TEMPLATE_VBOXWEBR3EXE_CXXFLAGS += $(VBOX_GCC_Wno-misleading-indentation)
 endif
-if "$(VBOX_VCC_TOOL_STEM)" >= "VCC141"
+if "$(VBOX_VCC_TOOL_STEM)" >= "VCC140"
  # -wd4774: string(532): warning C4774: 'sprintf_s' : format string expected in argument 3 is not a string literal
  # -wd4458: stdsoap2.h(2644): warning C4458: declaration of 'type' hides class member
@@ -339,5 +339,5 @@
     $(VBOX_GSOAP_CXX_SOURCES)_CXXFLAGS.win += -wd4756 # v2.8.36/stdsoap2.cpp(14008) : warning C4756: overflow in constant arithmetic
    endif
-   if "$(VBOX_VCC_TOOL_STEM)" >= "VCC141"
+   if "$(VBOX_VCC_TOOL_STEM)" >= "VCC140"
     $(VBOX_GSOAP_CXX_SOURCES)_CXXFLAGS.win += -wd4456 # stdsoap2.cpp(3127): warning C4456: declaration of 'i' hides previous local declaration
    endif
@@ -386,5 +386,5 @@
 	.
  vboxwebsrv_CXXFLAGS.win += -bigobj
- if "$(VBOX_VCC_TOOL_STEM)" >= "VCC141"
+ if "$(VBOX_VCC_TOOL_STEM)" >= "VCC140"
   vboxwebsrv_CXXFLAGS.win += -wd4774 # string(532): warning C4774: 'sprintf_s' : format string expected in argument 3 is not a string literal
   vboxwebsrv_CXXFLAGS.win += -wd4458 # stdsoap2.h(2644): warning C4458: declaration of 'type' hides class member
Index: trunk/src/libs/libxml2-2.9.4/Makefile.kmk
===================================================================
--- trunk/src/libs/libxml2-2.9.4/Makefile.kmk	(revision 84410)
+++ trunk/src/libs/libxml2-2.9.4/Makefile.kmk	(revision 84411)
@@ -37,5 +37,5 @@
  VBox-libxml2_CFLAGS.win   += -wd4005 # sdk\v7.1\include\sal_supp.h(57) : warning C4005: '__useHeader' : macro redefinition
 endif
-if "$(VBOX_VCC_TOOL_STEM)" >= "VCC141"
+if "$(VBOX_VCC_TOOL_STEM)" >= "VCC140"
  VBox-libxml2_CFLAGS.win   += -wd4777 # timsort.h(326): warning C4777: 'fprintf' : format string '%lu' requires an argument of type 'unsigned long', but variadic argument 1 has type 'unsigned int'
  VBox-libxml2_CFLAGS.win   += -wd4477 # timsort.h(326): warning C4477: 'fprintf' : format string '%lu' requires an argument of type 'unsigned long', but variadic argument 1 has type 'size_t'