Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 84513)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 84516)
@@ -1308,4 +1308,9 @@
 }
 
+void UIVirtualBoxManager::sltPerformRefreshMachine()
+{
+    m_pWidget->refreshMachine();
+}
+
 void UIVirtualBoxManager::sltShowMachineInFileManager()
 {
@@ -1585,4 +1590,6 @@
     connect(actionPool()->action(UIActionIndexST_M_Group_S_ShowLogDialog), &UIAction::triggered,
             this, &UIVirtualBoxManager::sltOpenLogViewerWindow);
+    connect(actionPool()->action(UIActionIndexST_M_Group_S_Refresh), &UIAction::triggered,
+            this, &UIVirtualBoxManager::sltPerformRefreshMachine);
     connect(actionPool()->action(UIActionIndexST_M_Group_S_ShowInFileManager), &UIAction::triggered,
             this, &UIVirtualBoxManager::sltShowMachineInFileManager);
@@ -1617,4 +1624,6 @@
     connect(actionPool()->action(UIActionIndexST_M_Machine_S_ShowLogDialog), &UIAction::triggered,
             this, &UIVirtualBoxManager::sltOpenLogViewerWindow);
+    connect(actionPool()->action(UIActionIndexST_M_Machine_S_Refresh), &UIAction::triggered,
+            this, &UIVirtualBoxManager::sltPerformRefreshMachine);
     connect(actionPool()->action(UIActionIndexST_M_Machine_S_ShowInFileManager), &UIAction::triggered,
             this, &UIVirtualBoxManager::sltShowMachineInFileManager);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 84513)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 84516)
@@ -248,4 +248,7 @@
         /** Handles call to close machine Log Viewer window. */
         void sltCloseLogViewerWindow();
+
+        /** Handles call to refresh machine. */
+        void sltPerformRefreshMachine();
 
         /** Handles call to show machine in File Manager. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 84513)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 84516)
@@ -129,4 +129,9 @@
 {
     m_pPaneChooser->moveMachineToNewGroup();
+}
+
+void UIVirtualBoxManagerWidget::refreshMachine()
+{
+    m_pPaneChooser->refreshMachine();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 84513)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 84516)
@@ -144,4 +144,6 @@
         /** Moves machine to a new group. */
         void moveMachineToNewGroup();
+        /** Refreshes machine. */
+        void refreshMachine();
         /** Sorts group. */
         void sortGroup();
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp	(revision 84513)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp	(revision 84516)
@@ -129,4 +129,10 @@
     AssertPtrReturnVoid(model());
     model()->moveSelectedMachineItemsToNewGroupItem();
+}
+
+void UIChooser::refreshMachine()
+{
+    AssertPtrReturnVoid(model());
+    model()->refreshSelectedMachineItems();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h	(revision 84513)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h	(revision 84516)
@@ -138,4 +138,6 @@
         /** Moves machine to a new group. */
         void moveMachineToNewGroup();
+        /** Refreshes machine. */
+        void refreshMachine();
         /** Sorts group. */
         void sortGroup();
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 84513)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 84516)
@@ -727,4 +727,76 @@
 }
 
+void UIChooserModel::refreshSelectedMachineItems()
+{
+    /* Gather list of current unique inaccessible machine-items: */
+    QList<UIChooserItemMachine*> inaccessibleMachineItemList;
+    UIChooserItemMachine::enumerateMachineItems(selectedItems(), inaccessibleMachineItemList,
+                                                UIChooserItemMachineEnumerationFlag_Unique |
+                                                UIChooserItemMachineEnumerationFlag_Inaccessible);
+
+    /* Prepare item to be selected: */
+    UIChooserItem *pSelectedItem = 0;
+
+    /* For each machine-item: */
+    foreach (UIChooserItemMachine *pItem, inaccessibleMachineItemList)
+    {
+        AssertPtrReturnVoid(pItem);
+        switch (pItem->cacheType())
+        {
+            case UIVirtualMachineItemType_Local:
+            {
+                /* Recache: */
+                pItem->recache();
+
+                /* Became accessible? */
+                if (pItem->accessible())
+                {
+                    /* Acquire machine ID: */
+                    const QUuid uId = pItem->id();
+                    /* Reload this machine: */
+                    sltReloadMachine(uId);
+                    /* Select first of reloaded items: */
+                    if (!pSelectedItem)
+                        pSelectedItem = root()->searchForItem(uId.toString(),
+                                                              UIChooserItemSearchFlag_Machine |
+                                                              UIChooserItemSearchFlag_ExactId);
+                }
+
+                break;
+            }
+            case UIVirtualMachineItemType_CloudFake:
+            {
+                /* Create list cloud machines task: */
+                UIChooserItem *pParent = pItem->parentItem();
+                AssertPtrReturnVoid(pParent);
+                UIChooserItem *pParentOfParent = pParent->parentItem();
+                AssertPtrReturnVoid(pParentOfParent);
+                UITaskCloudListMachines *pTask = new UITaskCloudListMachines(pParentOfParent->name(),
+                                                                             pParent->name());
+                AssertPtrReturnVoid(pTask);
+                uiCommon().threadPoolCloud()->enqueueTask(pTask);
+
+                break;
+            }
+            case UIVirtualMachineItemType_CloudReal:
+            {
+                /* Much more simple than for local items, we are not reloading them, just refreshing: */
+                pItem->cache()->toCloud()->updateInfoAsync(false /* delayed */);
+
+                break;
+            }
+            default:
+                break;
+        }
+    }
+
+    /* Some item to be selected? */
+    if (pSelectedItem)
+    {
+        pSelectedItem->makeSureItsVisible();
+        setSelectedItem(pSelectedItem);
+    }
+}
+
 void UIChooserModel::sortSelectedGroupItem()
 {
@@ -976,80 +1048,4 @@
 }
 
-void UIChooserModel::sltPerformRefreshAction()
-{
-    /* Check if action is enabled: */
-    if (!actionPool()->action(UIActionIndexST_M_Group_S_Refresh)->isEnabled())
-        return;
-
-    /* Gather list of current unique inaccessible machine-items: */
-    QList<UIChooserItemMachine*> inaccessibleMachineItemList;
-    UIChooserItemMachine::enumerateMachineItems(selectedItems(), inaccessibleMachineItemList,
-                                                UIChooserItemMachineEnumerationFlag_Unique |
-                                                UIChooserItemMachineEnumerationFlag_Inaccessible);
-
-    /* Prepare item to be selected: */
-    UIChooserItem *pSelectedItem = 0;
-
-    /* For each machine-item: */
-    foreach (UIChooserItemMachine *pItem, inaccessibleMachineItemList)
-    {
-        AssertPtrReturnVoid(pItem);
-        switch (pItem->cacheType())
-        {
-            case UIVirtualMachineItemType_Local:
-            {
-                /* Recache: */
-                pItem->recache();
-
-                /* Became accessible? */
-                if (pItem->accessible())
-                {
-                    /* Acquire machine ID: */
-                    const QUuid uId = pItem->id();
-                    /* Reload this machine: */
-                    sltReloadMachine(uId);
-                    /* Select first of reloaded items: */
-                    if (!pSelectedItem)
-                        pSelectedItem = root()->searchForItem(uId.toString(),
-                                                              UIChooserItemSearchFlag_Machine |
-                                                              UIChooserItemSearchFlag_ExactId);
-                }
-
-                break;
-            }
-            case UIVirtualMachineItemType_CloudFake:
-            {
-                /* Create list cloud machines task: */
-                UIChooserItem *pParent = pItem->parentItem();
-                AssertPtrReturnVoid(pParent);
-                UIChooserItem *pParentOfParent = pParent->parentItem();
-                AssertPtrReturnVoid(pParentOfParent);
-                UITaskCloudListMachines *pTask = new UITaskCloudListMachines(pParentOfParent->name(),
-                                                                             pParent->name());
-                AssertPtrReturnVoid(pTask);
-                uiCommon().threadPoolCloud()->enqueueTask(pTask);
-
-                break;
-            }
-            case UIVirtualMachineItemType_CloudReal:
-            {
-                /* Much more simple than for local items, we are not reloading them, just refreshing: */
-                pItem->cache()->toCloud()->updateInfoAsync(false /* delayed */);
-
-                break;
-            }
-            default:
-                break;
-        }
-    }
-
-    /* Some item to be selected? */
-    if (pSelectedItem)
-    {
-        pSelectedItem->makeSureItsVisible();
-        setSelectedItem(pSelectedItem);
-    }
-}
-
 void UIChooserModel::sltRemoveSelectedMachine()
 {
@@ -1309,8 +1305,4 @@
     connect(actionPool()->action(UIActionIndexST_M_Machine_S_Remove), &UIAction::triggered,
             this, &UIChooserModel::sltRemoveSelectedMachine);
-    connect(actionPool()->action(UIActionIndexST_M_Group_S_Refresh), &UIAction::triggered,
-            this, &UIChooserModel::sltPerformRefreshAction);
-    connect(actionPool()->action(UIActionIndexST_M_Machine_S_Refresh), &UIAction::triggered,
-            this, &UIChooserModel::sltPerformRefreshAction);
     connect(actionPool()->action(UIActionIndexST_M_Machine_S_Search), &UIAction::triggered,
             this, &UIChooserModel::sltShowHideSearchWidget);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 84513)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 84516)
@@ -224,4 +224,6 @@
         /** Starts or shows selected items. */
         void startOrShowSelectedItems();
+        /** Refreshes selected machine items. */
+        void refreshSelectedMachineItems();
         /** Sorts selected [parent] group item. */
         void sortSelectedGroupItem();
@@ -297,6 +299,4 @@
     /** @name Children stuff.
       * @{ */
-        /** Handles refresh request. */
-        void sltPerformRefreshAction();
         /** Handles remove selected machine request. */
         void sltRemoveSelectedMachine();